﻿package {
	// PhysicalN900 library version 0.1
	
	import flash.events.*;
	import flash.net.*;
	import flash.system.Security;

	public class PhysicalN900 {

		var responseHandler:Function;
		var faultHandler:Function;

		public function PhysicalN900(url:String, port:String,handler:Function,errorHandler:Function, method:String,str1:String = null, str2:String=null, str3:String=null) {

			responseHandler=handler;
			faultHandler=errorHandler;

			//loading policy
			Security.loadPolicyFile("http://" + url + ":" + port);

			loader.addEventListener(Event.COMPLETE, completeHandler);
			loader.addEventListener(SecurityErrorEvent.SECURITY_ERROR, securityErrorHandler);
			loader.addEventListener(IOErrorEvent.IO_ERROR, ioErrorHandler);

			request=new URLRequest("http://" + url + ":" + port);
			
			// Prepare XML
			// Add method name
			myXMLRPC.methodName[0]=method;
			// Add outgoing data
			if (str1 && str1.length != 0) {
				myXMLRPC.params[0].appendChild(new XML("<param><value><string>" + str1 +  "</string></value></param>"));
			}
			if (str2 && str2.length != 0) {
				myXMLRPC.params[0].appendChild(new XML("<param><value><string>" + str2 +  "</string></value></param>"));
			}
			if (str3 && str3.length != 0) {
				myXMLRPC.params[0].appendChild(new XML("<param><value><string>" + str3 +  "</string></value></param>"));
			}
			
			// Submit the XML
			request.method=URLRequestMethod.POST;
			request.contentType="text/xml; charset=utf-8";
			request.data = "<?xml version=\"1.0\"?>" + myXMLRPC.toString() + "/n";
			
			try {
				loader.load(request);
			} catch (error:Error) {
				trace("Unable to load requested document.");
			}
		}

		private var request:URLRequest;
		private var xmlRpcTemplate:String='<methodCall><methodName>echo</methodName><params></params></methodCall>';
		private var myXMLRPC:XML=new XML(xmlRpcTemplate);
		private var loader:URLLoader = new URLLoader();

		private function completeHandler(event:Event):void {
			var xml:XML=new XML(loader.data);
			trace("Event.COMPLETE: " + loader.data);
			
			var data:String;
			 if (xml.fault[0]){
				 data = xml.fault[0].value[0].struct[0].member[1].value[0].string[0];
				 faultHandler("[Server error]: " + data);
			 } else {
				 data = xml.params[0].param[0].value[0].string[0];
				 responseHandler(data);
			 }
		}

		// Error handling
		private function securityErrorHandler(event:SecurityErrorEvent):void {
			//trace("securityErrorHandler: " + event);
			faultHandler("[Flash error]: " + event.toString());
		}

		private function ioErrorHandler(event:IOErrorEvent):void {
			//trace("ioErrorHandler: " + event);
			faultHandler("[Flash error]: " + event.toString());
		}
	}
}