// 2010 Forrest Oliphant 
// Media Lab Helsinki http://mlab.uiah.fi/paja
// Experiencing with analogWrite(pulse-wide modulation) command

int brightness = 0;

int yellowPin = 11;
int redPin = 10;
int greenPin = 9;

// Import Messenger library
#include <Messenger.h>
// Instantiate Messenger object with the default separator 
// (default is the space character)
Messenger message = Messenger();

void setup(){
  Serial.begin(9600); 
  // Attach callback function to the Messenger
  message.attach(messageReady);
}

void loop(){
  // The following line is the most effective way to receive incoming data
  while (Serial.available())  message.process(Serial.read () );

  //  analogWrite(yellowPin, brightness);
  //  analogWrite(redPin, 255-brightness);
  //  analogWrite(greenPin, brightness);
  //  delay(5);
  //  brightness = brightness>=255 ? 0 : brightness+1;
}

//Reading incoming data
void messageReady(){
  // Checks to see if the message is complete
  if (message.available()){
    // read first char
    switch (message.readChar()){
    case 'w':
      writeValue();
      break;
    default:
      Serial.println("1st char error");
    }
  }
}

//Send values
void writeValue(){
  if(message.readChar() == 'a'){
    int pin = message.readInt();
    switch (pin){
    case 11:
      analogWrite(yellowPin, message.readInt());
      Serial.println("ok yellow "+message.readInt());
      break;
    case 10:
      analogWrite(redPin, message.readInt());
      Serial.println("ok red "+message.readInt());
      break;
    case 9:
      analogWrite(greenPin, message.readInt());
      Serial.println("ok green "+message.readInt());
      break;
    default:
      Serial.println("pin number error");
    }
  } 
  else {
    Serial.println("2nd char error");
  }
}


